//+------------------------------------------------------------------+
//|                                                       #dtosc.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"


#property indicator_separate_window
#property indicator_buffers 4
#property indicator_minimum  -20
#property indicator_maximum  120
#property indicator_color1  DeepSkyBlue
#property indicator_width1  4
#property indicator_color2  OrangeRed
#property indicator_style2  STYLE_DASH
#property indicator_color3  LimeGreen
#property indicator_width3  2
#property indicator_color4  Crimson
#property indicator_width4  2
#property indicator_level1  5
#property indicator_level2  95
#property indicator_levelcolor Magenta
#property indicator_levelstyle STYLE_DOT


//
//
//
//
//

   extern string TimeFrame     = "Current time frame";
   extern int    RsxLength     = 14;
   extern int    OmaLength     = 5;
   extern double OmaSpeed      = 8.0;
   extern bool   OmaAdaptive   = true;
   extern int    PeriodStoch   = 8;
   extern int    PeriodSK      = 5;
   extern int    PeriodSD      = 3;
   extern int    HighLowPeriod = 30;
   extern bool   ShowChannel   = true;   
   extern int    MAMode        = 3; //    0=SMA,1=EMA,2=SMMA, 3=LWMA
   extern bool   Interpolate   = true;
   
//
//
//
//
//

double SK[];
double SD[];
double StoRSI[];
double RSI[];
double HighBuffer[];
double LowBuffer[];
string IndicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
      IndicatorBuffers(6);
      SetIndexBuffer(0,SK);
      SetIndexBuffer(1,SD);
      SetIndexBuffer(2,LowBuffer);
      SetIndexBuffer(3,HighBuffer);
      SetIndexBuffer(4,StoRSI);
      SetIndexBuffer(5,RSI);
      
      
      if (ShowChannel)
            {
               SetIndexStyle(2,DRAW_LINE);
               SetIndexStyle(3,DRAW_LINE);
            }
         else      
            {
               SetIndexStyle(2,DRAW_NONE);
               SetIndexStyle(3,DRAW_NONE);
            }

   //
   //
   //
   //
   //
   
      IndicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);   

   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" DTOSC Channel ("+RsxLength+","+PeriodStoch+","+PeriodSK+","+PeriodSD+")");
return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit;
   int counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
             limit=MathMin(Bars-counted_bars,Bars-1);
             if (returnBars) { SK[0] = limit; return(0); }
             
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--)
      {
         RSI[i] = iCustom(NULL,0,"rsx on oma",RsxLength,PRICE_CLOSE,OmaLength,OmaSpeed,OmaAdaptive,0,i);
         double LLV = RSI[ArrayMinimum(RSI,PeriodStoch,i)];
         double HHV = RSI[ArrayMaximum(RSI,PeriodStoch,i)];
         if ((HHV-LLV)!=0)
               StoRSI[i] = 100.0*((RSI[i] - LLV)/(HHV - LLV));
         else  StoRSI[i] = 0;
         
      }   
      for(i=limit; i>=0; i--) SK[i] = iMAOnArray(StoRSI,0,PeriodSK,0,MAMode,i);
      for(i=limit; i>=0; i--) SD[i] = iMAOnArray(    SK,0,PeriodSD,0,MAMode,i);
      for(i=limit; i>=0; i--) LowBuffer[i] = StoRSI[ArrayMinimum(StoRSI,HighLowPeriod,i)];
      for(i=limit; i>=0; i--) HighBuffer[i]= StoRSI[ArrayMaximum(StoRSI,HighLowPeriod,i)];
      
      
   return(0);
}
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y           = iBarShift(NULL,timeFrame,Time[i]);
         SK[i]        = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxLength,OmaLength,OmaSpeed,OmaAdaptive,PeriodStoch,PeriodSK,PeriodSD,HighLowPeriod,ShowChannel,MAMode,0,y);
         SD[i]        = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxLength,OmaLength,OmaSpeed,OmaAdaptive,PeriodStoch,PeriodSK,PeriodSD,HighLowPeriod,ShowChannel,MAMode,1,y);
         LowBuffer[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxLength,OmaLength,OmaSpeed,OmaAdaptive,PeriodStoch,PeriodSK,PeriodSD,HighLowPeriod,ShowChannel,MAMode,2,y);
         HighBuffer[i]= iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",RsxLength,OmaLength,OmaSpeed,OmaAdaptive,PeriodStoch,PeriodSK,PeriodSD,HighLowPeriod,ShowChannel,MAMode,3,y); 
         //
         //
         //
         //
         //
      
         if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if (!Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               SK[i+k] = SK[i] +(SK[i+n]-SK[i])*k/n;
               SD[i+k] = SD[i] +(SD[i+n]-SD[i])*k/n;
            }               
   }               

   //
   //
   //
   //
   //
             
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}